Merge branch 'upstream'
[automated-distro-installer] / fai / config / scripts / DEBIAN / 30-interface
index 72f04a00781407bce1e5fa7b17b9f18787082d8c..5955f7b3b9bdf76efa4ec398f288bac79f398eb1 100755 (executable)
@@ -3,18 +3,63 @@
 # modified from upstream fai example
 error=0; trap 'error=$(($?>$error?$?:$error))' ERR # save maximum error code
 
+netplan_yaml() {
+    # network configuration using ubuntu's netplan.io
+    local IFNAME="$1"
+    local METHOD="$2"
+    echo     "Generating netplan configuration for $IFNAME ($METHOD)" >&2
+    echo     "# generated by FAI"
+    echo     "network:"
+    echo     "  version: 2"
+    echo     "  renderer: $RENDERER"
+    case "$RENDERER" in
+      networkd)
+        echo     "  ethernets:"
+        echo     "    $IFNAME:"
+        case "$METHOD" in
+          dhcp)
+            echo "      dhcp4: true"
+            ;;
+          static)
+            echo "      addresses: [$CIDR]"
+            echo "      gateway4: $GATEWAYS_1"
+            echo "      nameservers:"
+            echo "        search: [$DOMAIN]"
+            echo "        addresses: [${DNSSRVS// /, }]"
+            ;;
+        esac
+    esac
+}
+
+iface_stanza() {
+    # classic network configuration using /etc/network/interfaces
+    local IFNAME="$1"
+    local METHOD="$2"
+    echo "Generating interface configuration for $IFNAME ($METHOD)" >&2
+    echo "# generated by FAI"
+    echo "auto $IFNAME"
+    echo "iface $IFNAME inet $METHOD"
+    case "$METHOD" in
+      static)
+        echo "    address $IPADDR"
+        echo "    netmask $NETMASK"
+        echo "    broadcast $BROADCAST"
+        echo "    gateway $GATEWAYS"
+        ;;
+    esac
+}
+
 newnicnames() {
 
     # determine predictable network names only for stretch and above
 
     [ $do_init_tasks -eq 0 ] && return
-
+    [ -z "$NIC1" ] && return
     ver=$($ROOTCMD dpkg-query --showformat='${Version}' --show udev)
     if dpkg --compare-versions $ver lt 220-7; then
        return
     fi
 
-    [ -z "$NIC1" ] && return
 
     fields="ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH"
     for field in $fields; do
@@ -34,13 +79,25 @@ newnicnames() {
 }
 
 if [ -z "$NIC1" ]; then
-    echo "ERROR: \$NIC1 is not defined. Cannot configure /etc/network/interfaces properly."
+    echo "WARNING: \$NIC1 is not defined. Cannot add ethernet to /etc/network/interfaces."
 fi
-newnicnames
 CIDR=$(ip -o -f inet addr show $NIC1 | awk '{print $4}')
-if ifclass DHCPC && [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]; then
+newnicnames
+
+case "$FAI_ACTION" in
+  install|dirinstall)
+    ifclass DHCPC && METHOD=dhcp || METHOD=static
+    ifclass XORG && RENDERER=NetworkManager || RENDERER=networkd
 
-    if ifclass VM; then
+    if [ -d $target/etc/netplan ]; then
+        # Ubuntu >= 17.10 with netplan.io
+        if [ -n "$NIC1" ]; then
+            netplan_yaml $NIC1 $METHOD > $target/etc/netplan/01-${NIC1}.yaml
+        fi
+    elif [ -d $target/etc/network/interfaces.d ]; then
+        # ifupdown >= 0.7.41 (Debian >= 8, Ubuntu >= 14.04)
+
+      if ifclass VM; then
         # note, this condition would apply to the elif below too,
         # but I don't specify a static ip in fai, so not bothering
         cat > $target/etc/network/interfaces <<-EOF
@@ -49,7 +106,7 @@ if ifclass DHCPC && [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]; t
        iface lo inet loopback
        iface $NIC1 inet dhcp
 EOF
-    else
+      else
         cat > $target/etc/network/interfaces <<-EOF
         # generated by FAI
         auto lo br0
@@ -65,21 +122,22 @@ EOF
           bridge_stp off
           bridge_maxwait 0
 EOF
+      fi
+    else
+      (
+        iface_stanza lo loopback
+        iface_stanza $NIC1 $METHOD
+      ) > $target/etc/network/interfaces
     fi
-elif [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]; then
-    [ -n "$CIDR" ] && cat > $target/etc/network/interfaces <<-EOF
-       # generated by FAI
-       auto lo $NIC1
-       iface lo inet loopback
-       iface $NIC1 inet static
-         address $CIDR
-         gateway $GATEWAYS
-EOF
-    [ -n "$NETWORK" ] && echo "localnet $NETWORK" > $target/etc/networks
-    if [ ! -L $target/etc/resolv.conf -a -e /etc/resolv.conf ]; then
-       cp -p /etc/resolv.conf $target/etc
+
+    if ! ifclass DHCPC ; then
+        [ -n "$NETWORK" ] && echo "localnet $NETWORK" > $target/etc/networks
+        if [ ! -L $target/etc/resolv.conf -a -e /etc/resolv.conf ]; then
+            cp -p /etc/resolv.conf $target/etc
+        fi
     fi
-fi
+    ;;
+esac
 
 # here fcopy is mostly used, when installing a client for running in a
 # different subnet than during the installation